import calendar
import datetime
import time

print('''模块进行导入时，有几种语法格式可以使用，比如：
import importable
import importable1,importable2,...，importableN
import importable as preferred_name''')
print('''下面给出了一些其他的导入语法格式：
from importable import object as preferred_name
from importable import object1, object2，...，objectN
from importable import （object1, object2，object3, object4， object5,object6，...，objectN）
from importable import *''')
print('''在上面最后一种语法格式中，*意味着“导入非私有的一切对象”，在实践中，这意味着导入模块中的每个对象（除了那些名称以下划线引导的对象），
或者，如果模块有一个全局的_all_变量，其中存放一个名称列表，就导入名称包含在_all_变量中的所有对象。''')
print('''下面给出一些import语句实例：
import os
print(os.path.basename(filename))  # 安全的完全限定名称存取

import os.path as path 
print(path.basename(filename))  #存在与path名称冲突的风险

from os import path
print(path.basename(filename)) #存在与path名称冲突的风险

from os.path import basename 
print(basename(filename))  #存在与basename名称冲突的风险

from os.path import *
print(basename(filename))   #存在大量名称冲突的风险''')

print(
    '''对自定义模块的文件名，我们将其第一个字母用大写字母表示，这有助于避免名称冲突（至少在UNIX上），因为标准库文件名是小写的。''')
print('''一个可用于此目的的简单方法是执行 docstrings中的实例，并确信其可以产生期待的结果，通过向该模块的.py文件末尾追加仅三行代码，就可以实现这一目的：
if  __name__ =="__main__":
    import doctest 
    doctest.testmod()''')
print('''.py文件运行时，Python会为该程序创建一个名为__name__的变量，并将其设置为字符串"__main__”，因此，如果我们要像运行程序一样运行.py文件,
 Python将把变量__name__设置为"__main__”，此时if条件得以满足，最后两行代码也得以执行。doctest.testmod()函数使用Python的内省功能来发现模块及其docstrings中的所有函数，
 并尝试执行其发现的所有docstring代码段。以这种方式运行模块时，只有发生错误的情况下，才会产生输出信息。''')

